#include "Vista.h"
C       This file creates an array which keeps track of masked pixels.
C       Images in VISTA can be of any size, since the memory for
C       holding the images is dynamic.  The mask list, on the other
C       hand is a fixed size.

C      Length of mask array.
	INTEGER         MAXR, MAXC
	PARAMETER       (MAXR = 2048, MAXC = 2048)
	INTEGER         MASKSIZE
	PARAMETER       (MASKSIZE=MAXR*MAXC/32+1)

	INTEGER*4       PIXMASK	
        LOGICAL	        VERBOSEMASK
	COMMON  /MASKLIST/      PIXMASK(MASKSIZE), VERBOSEMASK

C       Each bit in the integer array represents one pixel.  If a bit is
C       set to 1, the pixel it represents is masked.   A zero bit means
C       the pixel is not masked.

C       Each pixel (COL,ROW) is assigned the bit number:
C
C                       ROW * MAXC + COL
C
C       Note that ROW and COL run from ZERO to MAXR-1 and MAXC-1, respectively.
C       The bits are numbered from zero.  Bit zero is the last bit in
C       MASK(MASKSIZE).  Bit 1 is the second-last bit in MASK(MASKSIZE).
C       Bit 32 is the first bit in MASK(MASKSIZE-1), and so on.
C       Note that the ROW and COL are absolute row and column numbers, not
C       array indices.
