#include "Vista.h"
       SUBROUTINE  PLOTFOCUS
C
C=======================================================================
C
C This subroutine plots focus data from stars on the
C VISTA photometry list.
C
#ifdef VMS
      INCLUDE 'VINCLUDE:VISTALINK.INC'
      INCLUDE 'VINCLUDE:PHOTFILES.INC'
      INCLUDE 'VINCLUDE:OUTPUT.INC'
#else
      INCLUDE 'vistadisk/source/include/vistalink.inc'
      INCLUDE 'vistadisk/source/include/photfiles.inc'
      INCLUDE 'vistadisk/source/include/output.inc'
#endif
      LOGICAL KEYCHECK, HARD
      CHARACTER PARM*8, LABEL*80, PSFILE*80
      REAL*4 PHOTDATA(NUMDATA)
      PARAMETER (MAXPTS = 100)
      REAL F(MAXPTS), FWHMX(MAXPTS), FWHMY(MAXPTS), ANGLE(MAXPTS)
      REAL STYLE(MAXPTS), ELL(MAXPTS), YMAX(4), YMIN(4)

      CALL KEYINIT
      CALL KEYDEF('HARD')
      CALL KEYDEF('SCALE=')
      IF (.NOT. KEYCHECK()) THEN
        XERR = .TRUE.
        RETURN
      END IF

      HARD = .FALSE.
      SCALE = 1.
      DO 4701 I = 1, NCON
        IF (WORD(I) .EQ. 'HARD') THEN
          HARD = .TRUE.
        ELSE IF (WORD(I)(1:6) .EQ. 'SCALE=') THEN
          CALL ASSIGN(WORD(I),SCALE,PARM)
          IF (XERR) RETURN
        END IF 
 4701 CONTINUE

      call plotsetup(hard,.true.,psfile,.false.,.false.,.false.,xerr)
      if (xerr) return

      xmin = 1.e10
      xmax = -1.e10 
      do 4400 i=1,4
        ymax(i) = -1.e30
        ymin(i) = 1.e30
4400  continue
      do 4401 i=1,nstars

        if (i .gt. maxpts) then
          print *, 'too many stars in photometry file'
          goto 4402
        end if
	call getphotrec(label,photdata,i)
	f(i) = photdata(focus)
	fwhmx(i) = photdata(sigx)*2.354*scale
	fwhmy(i) = photdata(sigy)*2.354*scale
	angle(i) = photdata(pa)
        if (fwhmx(i) .gt. fwhmy(i)) then
          tmp = fwhmx(i)
          fwhmx(i) = fwhmy(i)
          fwhmy(i) = tmp
          angle(i) = angle(i) + 90
          if (angle(i) .gt. 180) angle(i) = angle(i) - 360
        end if
        ell(i) = fwhmx(i) / fwhmy(i)
	style(i) = (photdata(nalter)+2)*10
	
	xmin = min(xmin,f(i))
	xmax = max(xmax,f(i))

	ymax(3) = max(ymax(3),fwhmx(i))
	ymax(4) = max(ymax(4),fwhmy(i))
	ymax(1) = max(ymax(1),angle(i))
	ymax(2) = max(ymax(2),ell(i))
	ymin(3) = min(ymin(3),fwhmx(i))
	ymin(4) = min(ymin(4),fwhmy(i))
	ymin(1) = min(ymin(1),angle(i))
	ymin(2) = min(ymin(2),ell(i))

4401  continue
4402  continue

      xrange = xmax-xmin
      if (xrange .gt. 0) then
        xmin = xmin - 0.05*xrange
        xmax = xmax + 0.05*xrange
      else
        xmin = xmin - xmin/10.
        xmax = xmax + xmin/10.
      end if

      ymin(1) = -180.
      ymax(1) = 180.
      ymin(2) = 0.
      ymax(2) = 1.
      ymin(3) = 0.
      ymax(3) = min(10.*scale,ymax(3) + 0.5)
      ymin(4) = 0.
      ymax(4) = min(10.*scale,ymax(4) + 0.5)
      do iwind = 1, 4
        call PMGO(window)(2,2,iwind)
        call PMGO(setlim)(xmin,ymin(iwind),xmax,ymax(iwind))
        call PMGO(box)(1,2)
        if (iwind .eq. 3) then
          call PMGO(points)(style,nstars,f,fwhmx,nstars)
          call PMGO(xlabel)(5,'Focus')
          call PMGO(ylabel)(6,'x FWHM')
        else if (iwind .eq. 4) then
          call PMGO(points)(style,nstars,f,fwhmy,nstars)
          call PMGO(xlabel)(5,'Focus')
          call PMGO(ylabel)(6,'y FWHM')
        else if (iwind .eq. 1) then
          call PMGO(points)(style,nstars,f,angle,nstars)
          call PMGO(xlabel)(5,'Focus')
          call PMGO(ylabel)(2,'PA')
        else if (iwind .eq. 2) then
          call PMGO(points)(style,nstars,f,ell,nstars)
          call PMGO(xlabel)(5,'Focus')
          call PMGO(ylabel)(11,'Ellipticity')
        end if
      end do

      IF (HARD) THEN
        N = PMGO(FILEPLOT)(0)
      ELSE 
        CALL PMGO(TIDLE)
      END IF
	
      RETURN
      END
